#ifndef JPEGDECODER_H
#define JPEGDECODER_H

#include <QObject>
#include <QByteArray>
#include <QRunnable>
#include <QPoint>
#include <QSize>
#include <QImage>

/*!
 * \brief Loads JPEG files on a separate thread
 */
class JpegDecoder : public QRunnable
{
    Q_OBJECT
public:
    JpegDecoder(const QByteArray &jpeg, const QPoint &position, const QSize &size);
    void run();
signals:
    void finished(const QImage &image, const QPoint &position, QSize &size);
private:
    QByteArray m_jpeg;
    QImage m_image;
    QPoint m_position;
    QSize m_size;
};

#endif // JPEGDECODER_H
