#ifndef UPLOADER_H
#define UPLOADER_H

#include <QVector>
#include <QOffscreenSurface>
#include <QOpenGLContext>
#include <QOpenGLFunctions>
#include <QOpenGLBuffer>
#include <QOpenGLTexture>
#include <QThreadPool>
#include <QtAlgorithms>

class Uploader : public QObject
{
public:
    Uploader();
    QOpenGLBuffer fill_buffer() const;
    QOpenGLBuffer draw_buffer() const;
    void startedUpdate();
    void gotCopyRect(const int src_x, const int src_y, const int width, const int height, const int dest_x, const int dest_y);
    void gotFillRect(const int x, const int y, const int width, const int height, const float red, const float green, const float blue);
    void gotBitmap(const QImage &image, const int x, const int y, const int width, const int height);
    void finishedUpdate();
private:
    QOffscreenSurface m_surface;
    QOpenGLContext m_uploader_context;

    QVector<float> m_fill_data;
    QOpenGLBuffer m_fill_buffer;

    QVector<float> m_draw_data;
    QOpenGLBuffer m_draw_buffer;

    QVector<*QOpenGLTexture> m_draw_textures;

    uchar m_decoders_running;
};

#endif // UPLOADER_H
